API reference
Coupons
A coupon contains information about a percent-off or amount-off discount you might want to apply to a customer. Coupons may be applied to subscriptions, invoices, checkout sessions, quotes, and more. Coupons do not work with conventional one-off charges or payment intents.
https://api.knoxapi.comCreate a coupon
POST/v1/coupons
You can create coupons easily via the coupon management page of the Stripe dashboard. Coupon creation is also accessible via the API if you need to create coupons on the fly. A coupon has either a percent_off or an amount_off and currency. If you set an amount_off, that amount will be subtracted from any invoice’s subtotal. For example, an invoice with a subtotal of 100 will have a final total of 0 if a coupon with an amount_off of 200 is applied to it and an invoice with a subtotal of 300 will have a final total of 100 if a coupon with an amount_off of 200 is applied to it.
Body parameters
amount_offintegerA positive integer representing the amount to subtract from an invoice total (required if
percent_offis not passed).applies_toobjectA hash containing directions for what this Coupon will apply discounts to.
Show 1 child parameter
productsarray of strings
currencystringThree-letter ISO code for the currency of the
amount_offparameter (required ifamount_offis passed).currency_optionsobjectCoupons defined in each available currency option (only supported if
amount_offis passed). Each key must be a three-letter ISO currency code and a supported currency.durationstringSpecifies how long the discount will be in effect if used on a subscription. Defaults to
once.Possible valuesforeveroncerepeating
duration_in_monthsintegerRequired only if
durationisrepeating, in which case it must be a positive integer that specifies the number of months the discount will be in effect.expandarray of stringsSpecifies which fields in the response should be expanded.
idstringUnique string of your choice that will be used to identify this coupon when applying it to a customer. If you don't want to specify a particular code, you can leave the ID blank and we'll generate a random code for you.
max_redemptionsintegerA positive integer specifying the number of times the coupon can be redeemed before it's no longer valid. For example, you might have a 50% off coupon that the first 20 readers of your blog can use.
metadataobjectSet of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to
metadata.namestringName of the coupon displayed to customers on, for instance invoices, or receipts. By default the
idis shown ifnameis not set.percent_offnumberA positive float larger than 0, and smaller or equal to 100, that represents the discount the coupon will apply (required if
amount_offis not passed).redeem_byintegerUnix timestamp specifying the last time at which the coupon can be redeemed (cannot be set to more than 5 years in the future). After the redeem_by date, the coupon can no longer be applied to new customers.
Returns
The coupon object.
curl -X POST https://api.knoxapi.com/v1/coupons \
-H "Authorization: Bearer $KNOX_SECRET_KEY"const Stripe = require('stripe');
const stripe = new Stripe(process.env.KNOX_SECRET_KEY, {host: 'api.knoxapi.com'});
const coupon = await stripe.coupons.create();import os
import stripe
client = stripe.StripeClient(
os.environ["KNOX_SECRET_KEY"],
base_addresses={"api": "https://api.knoxapi.com"},
)
coupon = client.v1.coupons.create()require 'stripe'
Stripe.api_key = ENV['KNOX_SECRET_KEY']
Stripe.api_base = 'https://api.knoxapi.com'
coupon = Stripe::Coupon.create(){
"amount_off": null,
"created": 1234567890,
"currency": "usd",
"duration": "forever",
"duration_in_months": 3,
"id": "Z4OV52SU",
"livemode": false,
"max_redemptions": null,
"metadata": {},
"name": "25.5% off",
"object": "coupon",
"percent_off": 25.5,
"redeem_by": 1234567890,
"times_redeemed": 0,
"valid": true
}List all coupons
GET/v1/coupons
Returns a list of your coupons.
Query parameters
createdobject | integerA filter on the list, based on the object
createdfield. The value can be a string with an integer Unix timestamp, or it can be a dictionary with a number of different query options.Show 4 child parameters
gtintegergteintegerltintegerlteinteger
ending_beforestringA cursor for use in pagination.
ending_beforeis an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting withobj_bar, your subsequent call can includeending_before=obj_barin order to fetch the previous page of the list.expandarray of stringsSpecifies which fields in the response should be expanded.
limitintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
starting_afterstringA cursor for use in pagination.
starting_afteris an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending withobj_foo, your subsequent call can includestarting_after=obj_fooin order to fetch the next page of the list.
Returns
A list of coupon objects.
curl -G https://api.knoxapi.com/v1/coupons \
-H "Authorization: Bearer $KNOX_SECRET_KEY" \
--data-urlencode limit=3const Stripe = require('stripe');
const stripe = new Stripe(process.env.KNOX_SECRET_KEY, {host: 'api.knoxapi.com'});
const page = await stripe.coupons.list({
limit: 3,
});import os
import stripe
client = stripe.StripeClient(
os.environ["KNOX_SECRET_KEY"],
base_addresses={"api": "https://api.knoxapi.com"},
)
page = client.v1.coupons.list(params={
"limit": 3,
})require 'stripe'
Stripe.api_key = ENV['KNOX_SECRET_KEY']
Stripe.api_base = 'https://api.knoxapi.com'
page = Stripe::Coupon.list({
limit: 3,
}){
"object": "list",
"url": "/v1/coupons",
"has_more": false,
"data": [
{
"amount_off": null,
"created": 1234567890,
"currency": "usd",
"duration": "forever",
"duration_in_months": 3,
"id": "Z4OV52SU",
"livemode": false,
"max_redemptions": null,
"metadata": {},
"name": "25.5% off",
"object": "coupon",
"percent_off": 25.5,
"redeem_by": 1234567890,
"times_redeemed": 0,
"valid": true
}
]
}Update a coupon
POST/v1/coupons/{coupon}
Updates the metadata of a coupon. Other coupon details (currency, duration, amount_off) are, by design, not editable.
Path parameters
couponstringRequired
Body parameters
currency_optionsobjectCoupons defined in each available currency option (only supported if the coupon is amount-based). Each key must be a three-letter ISO currency code and a supported currency.
expandarray of stringsSpecifies which fields in the response should be expanded.
metadataobjectSet of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to
metadata.namestringName of the coupon displayed to customers on, for instance invoices, or receipts. By default the
idis shown ifnameis not set.
Returns
The coupon object.
curl https://api.knoxapi.com/v1/coupons/Z4OV52SU \
-H "Authorization: Bearer $KNOX_SECRET_KEY" \
-d "metadata[order_id]=6735"const Stripe = require('stripe');
const stripe = new Stripe(process.env.KNOX_SECRET_KEY, {host: 'api.knoxapi.com'});
const coupon = await stripe.coupons.update('Z4OV52SU', {
metadata: {
order_id: '6735',
},
});import os
import stripe
client = stripe.StripeClient(
os.environ["KNOX_SECRET_KEY"],
base_addresses={"api": "https://api.knoxapi.com"},
)
coupon = client.v1.coupons.update("Z4OV52SU", params={
"metadata": {
"order_id": "6735",
},
})require 'stripe'
Stripe.api_key = ENV['KNOX_SECRET_KEY']
Stripe.api_base = 'https://api.knoxapi.com'
coupon = Stripe::Coupon.update('Z4OV52SU', {
metadata: {
order_id: '6735',
},
}){
"amount_off": null,
"created": 1234567890,
"currency": "usd",
"duration": "forever",
"duration_in_months": 3,
"id": "Z4OV52SU",
"livemode": false,
"max_redemptions": null,
"metadata": {},
"name": "25.5% off",
"object": "coupon",
"percent_off": 25.5,
"redeem_by": 1234567890,
"times_redeemed": 0,
"valid": true
}Retrieve a coupon
GET/v1/coupons/{coupon}
Retrieves the coupon with the given ID.
Path parameters
couponstringRequired
Query parameters
expandarray of stringsSpecifies which fields in the response should be expanded.
Returns
The coupon object.
curl https://api.knoxapi.com/v1/coupons/Z4OV52SU \
-H "Authorization: Bearer $KNOX_SECRET_KEY"const Stripe = require('stripe');
const stripe = new Stripe(process.env.KNOX_SECRET_KEY, {host: 'api.knoxapi.com'});
const coupon = await stripe.coupons.retrieve('Z4OV52SU');import os
import stripe
client = stripe.StripeClient(
os.environ["KNOX_SECRET_KEY"],
base_addresses={"api": "https://api.knoxapi.com"},
)
coupon = client.v1.coupons.retrieve("Z4OV52SU")require 'stripe'
Stripe.api_key = ENV['KNOX_SECRET_KEY']
Stripe.api_base = 'https://api.knoxapi.com'
coupon = Stripe::Coupon.retrieve('Z4OV52SU'){
"amount_off": null,
"created": 1234567890,
"currency": "usd",
"duration": "forever",
"duration_in_months": 3,
"id": "Z4OV52SU",
"livemode": false,
"max_redemptions": null,
"metadata": {},
"name": "25.5% off",
"object": "coupon",
"percent_off": 25.5,
"redeem_by": 1234567890,
"times_redeemed": 0,
"valid": true
}Delete a coupon
DELETE/v1/coupons/{coupon}
You can delete coupons via the coupon management page of the Stripe dashboard. However, deleting a coupon does not affect any customers who have already applied the coupon; it means that new customers can’t redeem the coupon. You can also delete coupons via the API.
Path parameters
couponstringRequired
Returns
The deleted_coupon object.
curl -X DELETE https://api.knoxapi.com/v1/coupons/Z4OV52SU \
-H "Authorization: Bearer $KNOX_SECRET_KEY"const Stripe = require('stripe');
const stripe = new Stripe(process.env.KNOX_SECRET_KEY, {host: 'api.knoxapi.com'});
const deletedCoupon = await stripe.coupons.del('Z4OV52SU');import os
import stripe
client = stripe.StripeClient(
os.environ["KNOX_SECRET_KEY"],
base_addresses={"api": "https://api.knoxapi.com"},
)
deleted_coupon = client.v1.coupons.delete("Z4OV52SU")require 'stripe'
Stripe.api_key = ENV['KNOX_SECRET_KEY']
Stripe.api_base = 'https://api.knoxapi.com'
deleted_coupon = Stripe::Coupon.delete('Z4OV52SU'){
"deleted": true,
"id": "Z4OV52SU",
"object": "coupon"
}Operations and schemas come from the pinned Stripe OpenAPI specification (MIT); response examples from its fixtures. Nested object definitions and enums are in the complete specification.